<div id="testrun-info-page" class="page-wrapper testrun-info">
    <div class="page">
        <zeb-page-header
            breadcrumb-custom-actions="$ctrl.breadcrumbsCustomActions"
            page-title="$ctrl.currentTitle">
            <button class="fixed-page-header__btn _launcher zf-primary-button no-animate"
                ng-click="$ctrl.downloadAllArtifacts()"
                ng-disabled="$ctrl.isControllerRefreshing"
                ng-if="$ctrl.test.artifactsToDownload.length">
                <md-icon aria-label="Download zip">archive</md-icon>
                <span>Artifacts</span>
            </button>
        </zeb-page-header>
        <div class="row testrun-info__container">
            <test-execution-history class="testrun-info__history"
                on-test-select="$ctrl.onHistoryElemClick($historyItem)"
                active-test-id="$ctrl.activeTestId"
                parent-test-id="$ctrl.parentTestId"
                execution-history="$ctrl.executionHistory"></test-execution-history>
            <div class="testrun-info__section col-md-12 no-padding"
                blur-filter
                blur-radius="1px"
                blur-active="{{$ctrl.isControllerRefreshing}}">
                <div class="row no-margin" ng-cloak>
                    <section class="panel panel-default no-margin">
                        <div class="panel-body no-padding">
                            <div class="testrun-info__tab-video-section col-md-4 col-sm-12 col-md-push-8 no-padding">
                                <div class="testrun-info__tab-video-section-wrapper">
                                    <div class="testrun-info__tab-additional">
                                        <table class="tab-additional__table">
                                            <tbody class="tab-additional__table-body">
                                                <tr class="tab-additional__table-row">
                                                    <td class="tab-additional__table-data _status _border-bottom">
                                                        <span class="material-icons data-icon">flag</span>
                                                        <span class="tab-additional__table-data _label">Status</span>
                                                    </td>
                                                    <td class="tab-additional__table-data _status-info _border-bottom">
                                                        <md-menu md-offset="30 20" class="tab-additional__menu">
                                                            <md-button class="menu__button"
                                                                aria-label="Additional menu"
                                                                ng-click="$mdMenu.open($event)"
                                                                ng-disabled="$ctrl.disabledTestRunsSettings()">
                                                                <span class="button-text _{{$ctrl.test.status.toLowerCase()}}">{{ $ctrl.test.status.split('_').join(' ').toLowerCase() }}</span>
                                                                <span class="material-icons button-icon" ng-class="{'_hidden': $ctrl.disabledTestRunsSettings()}">arrow_drop_down</span>
                                                            </md-button>
                                                            <md-menu-content class="tab-additional__menu-content">
                                                                <md-menu-item class="menu__item" ng-repeat="item in ['passed', 'failed']">
                                                                    <md-button ng-click="$ctrl.changeTestStatus($ctrl.test, item)">
                                                                        <span class="item-text {{item}}" md-menu-align-target>{{item}}</span>
                                                                    </md-button>
                                                                </md-menu-item>
                                                            </md-menu-content>
                                                        </md-menu>
                                                    </td>
                                                    <td class="tab-additional__table-data _issue _border-bottom" ng-if="$ctrl.displayLinkIssue()">
                                                        <button class="button" ng-click="$ctrl.showDetailsDialog($ctrl.test, $event)">
                                                            <span class="material-icons data-icon">bug_report</span>
                                                            <span>Link issue</span>
                                                        </button>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <table class="tab-additional__table">
                                            <tbody class="tab-additional__table-body">
                                                <tr class="tab-additional__table-row">
                                                    <td class="tab-additional__table-data _test-owner">
                                                        <span class="material-icons data-icon">person</span>
                                                        <span class="tab-additional__table-data _label">Owner</span>
                                                    </td>
                                                    <td class="tab-additional__table-data _test-owner-data">
                                                        <span class="tab-additional__table-content">{{ $ctrl.test.owner }}</span>
                                                    </td>
                                                </tr>
                                                <tr class="tab-additional__table-row">
                                                    <td class="tab-additional__table-data _started">
                                                        <span class="material-icons data-icon">access_time</span>
                                                        <span class="tab-additional__table-data _label">Started</span>
                                                    </td>
                                                    <td class="tab-additional__table-data _started-data">
                                                        <span>{{ $ctrl.test.startTime | date: 'HH:mm dd MMM yyyy'}}</span>
                                                    </td>
                                                </tr>
                                                <tr ng-if="$ctrl.test.finishTime && $ctrl.test.startTime && ($ctrl.test.finishTime - $ctrl.test.startTime) >= 0">
                                                    <td class="tab-additional__table-data _duration">
                                                        <span class="material-icons data-icon">timer</span>
                                                        <span class="tab-additional__table-data _label">Duration</span>
                                                    </td>
                                                    <td>
                                                        <duration duration-in-seconds="(($ctrl.test.finishTime - $ctrl.test.startTime) / 1000)">
                                                            <span ng-show="minutes">{{minutes}}m</span> <span ng-show="seconds">{{seconds}}s</span><span ng-show="!minutes && !seconds">&lt;1s</span>
                                                        </duration>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <table class="tab-additional__table"
                                            ng-if="$ctrl.test.issueReferences.length">
                                            <tbody class="tab-additional__table-body">
                                                <tr class="tab-additional__table-row" ng-if="$ctrl.test.issueReferences.length">
                                                    <td class="tab-additional__table-data _tickets">
                                                        <span class="material-icons data-icon">label_important_outline</span>
                                                        <span class="tab-additional__table-data _label">Tickets</span>
                                                    </td>
                                                    <td class="tab-additional__table-data _tickets-info">
                                                        <test-ticket class="issue-references"
                                                            ng-repeat="issueReference in $ctrl.test.issueReferences track by issueReference.id"
                                                            jira-integration="$ctrl.jiraIntegration"
                                                            issue-reference="issueReference"></test-ticket>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <table class="tab-additional__table"
                                            ng-if="$ctrl.labels.length">
                                            <tr class="tab-additional__table-row">
                                                <td class="tab-additional__table-data _labels">
                                                    <span class="material-icons data-icon">label_outline</span>
                                                    <span class="tab-additional__table-data _label">Labels</span>
                                                </td>
                                                <td class="tab-additional__table-data _labels-spinner" ng-if="!$ctrl.isIntegrationInitialized">
                                                    <md-progress-circular md-mode="indeterminate"
                                                        md-diameter="20px" class="tab-additional__label-spinner"></md-progress-circular>
                                                </td>
                                                <td class="tab-additional__table-data _labels-info" ng-if="$ctrl.isIntegrationInitialized">
                                                    <test-label class="tab-additional__label _label"
                                                        test-label="testLabel"
                                                        qtest-integration="$ctrl.qtestIntegration"
                                                        testrail-integration="$ctrl.testrailIntegration"
                                                        jira-integration="$ctrl.jiraIntegration"
                                                        ng-repeat="testLabel in $ctrl.labels | limitTo:$ctrl.labelsLimitCount track by testLabel.id"></test-label>
                                                    <button class="tab-additional__label _btn _label-more no-animate"
                                                        ng-click="$ctrl.showMore('labels')"
                                                        ng-if="$ctrl.labels.length > $ctrl.defaultLimitCount && $ctrl.labels.length > $ctrl.labelsLimitCount">
                                                        <md-icon>chevron_right</md-icon>
                                                    </button>
                                                    <button class="tab-additional__label _btn _label-less no-animate"
                                                        ng-click="$ctrl.showLess('labels')"
                                                        ng-if="$ctrl.labels.length > $ctrl.defaultLimitCount && $ctrl.labels.length <= $ctrl.labelsLimitCount">
                                                        <md-icon>chevron_left</md-icon>
                                                    </button>
                                                </td>
                                            </tr>
                                        </table>
                                        <table class="tab-additional__table"
                                            ng-if="$ctrl.test.atifactsToShow.length">
                                            <tbody class="tab-additional__table-body">
                                                <tr class="tab-additional__table-row" ng-if="$ctrl.test.atifactsToShow.length">
                                                    <td class="tab-additional__table-data _artifacts">
                                                        <span class="material-icons data-icon">link</span>
                                                        <span class="tab-additional__table-data _label">Test artifacts</span>
                                                    </td>
                                                    <td class="tab-additional__table-data _artifacts-info">
                                                        <a ng-repeat="artifact in $ctrl.test.artifacts | limitTo:$ctrl.artifactsLimitCount"
                                                            class="artifact-link"
                                                            href="{{::artifact.value}}"
                                                            target="_blank">{{ ::$ctrl.getArtifactName(artifact) }}</a>
                                                        <button class="tab-additional__artifact _btn _artifact-more no-animate"
                                                                ng-click="$ctrl.showMore('artifacts')"
                                                                ng-if="$ctrl.test.artifacts.length > $ctrl.defaultLimitCount && $ctrl.test.artifacts.length > $ctrl.artifactsLimitCount">
                                                            <md-icon>chevron_right</md-icon>
                                                            <span>{{$ctrl.test.artifacts.length - $ctrl.defaultLimitCount}}+</span>
                                                        </button>
                                                        <button class="tab-additional__artifact _btn _artifact-less no-animate"
                                                            ng-click="$ctrl.showLess('artifacts')"
                                                            ng-if="$ctrl.test.artifacts.length > $ctrl.defaultLimitCount && $ctrl.test.artifacts.length <= $ctrl.artifactsLimitCount">
                                                            <md-icon>chevron_left</md-icon>
                                                            <span>{{$ctrl.test.artifacts.length - $ctrl.defaultLimitCount}}-</span>
                                                        </button>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                        <test-sessions test="$ctrl.test" logs-view="true" sessions="$ctrl.sessions"></test-sessions>
                                    </div>
                                </div>
                            </div>
                            <div class="testrun-info__tab-table-wrapper col-md-8 col-sm-12 no-padding">
                                <div class="testrun-info__tab-table-row _head">
                                    <div class="testrun-info__tab-table-col _visuals">Visuals</div>
                                    <div class="testrun-info__tab-table-col _start">Start</div>
                                    <div class="testrun-info__tab-table-col _status">
                                        <md-menu md-offset="-20 40">
                                            <div aria-label="Open demo menu" ng-click="$mdMenu.open($event)" >
                                                <span class="testrun-info__status-button-icon _{{$ctrl.selectedLevel}}">Status</span>
                                                <span ng-if="$ctrl.selectedLevel === 'status'" class="material-icons _button-icon">filter_list</span>
                                                <md-icon md-svg-icon="checkedListIcon" ng-if="$ctrl.selectedLevel !== 'status'" class="material-icons selected-icon"></md-icon>
                                            </div>
                                            <md-menu-content width="2" class="_status dropdown-content">
                                                <md-menu-item ng-repeat="item in $ctrl.logLevels" class="dropdown__list">
                                                    <md-button ng-click="$ctrl.filterResults($index)"
                                                        ng-class="{ '_active': $ctrl.selectedLevel === item }"
                                                        class="listitem__button">
                                                        <span class="testrun-info__status-icon _{{item}} button__text">{{ item === 'status' ? 'All' : item }}</span>
                                                    </md-button>
                                                </md-menu-item>
                                            </md-menu-content>
                                        </md-menu>
                                    </div>
                                    <div class="testrun-info__tab-table-col _action">Action</div>
                                    <div class="testrun-info__tab-table-col _menu"></div>
                                </div>
                                <div class="testrun-info__tab-table-row"
                                    ng-repeat="logItem in $ctrl.filteredLogs track by logItem.uuidInternal"
                                    ng-attr-id="log-{{ $index }}"
                                    ng-class="{ 'selected-log-row': $ctrl.selectedLogRow === $index }"
                                    ng-if="$ctrl.logs.length"
                                    ng-click="$ctrl.selectLogRow($event, $index)">
                                    <div class="testrun-info__tab-table-col _visuals">
                                        <div class="testrun-info__tab-table-col _title" ng-if="logItem.urls && $ctrl.isMobile">Visuals</div>
                                        <div ng-if="logItem.urls" class="log-wrapper image-placeholder">
                                            <img ng-if="logItem.urls.thumb.path || logItem.urls.image.path"
                                                class="testrun-info__tab-table-img"
                                                ng-click="$ctrl.openImagesViewerModal($event, logItem.urls.image.path)"
                                                ng-src="{{logItem.urls.thumb.path || logItem.urls.image.path}}"
                                                title="log screen"
                                                alt="log screen" />
                                            <i ng-if="!logItem.urls.thumb.path && !logItem.urls.image.path" class="material-icons">insert_photo</i>
                                        </div>
                                    </div>
                                    <div class="testrun-info__tab-table-col _start">
                                        <div class="testrun-info__tab-table-col _title" ng-show="$ctrl.isMobile">Start</div>
                                        <div class="testrun-info__tab-table-col _start-wrapper">
                                            <span>{{logItem.timestamp | date: 'HH:mm:ss'}}</span>
                                        </div>
                                    </div>
                                    <div class="testrun-info__tab-table-col _status">
                                        <div class="testrun-info__tab-table-col _title" ng-show="$ctrl.isMobile">Status</div>
                                        <div class="testrun-info__tab-table-col _status-wrapper">
                                            <span class="testrun-info__status-icon {{logItem.level ? '_' + (logItem.level | lowercase) : ''}}">{{logItem.level}}<md-tooltip ng-if="logItem.threadName" md-direction="right">{{logItem.threadName}}</md-tooltip></span>
                                        </div>
                                    </div>
                                    <div class="testrun-info__tab-table-col _action">
                                        <div class="testrun-info__tab-table-col _title" ng-show="$ctrl.isMobile">Action</div>
                                        <div ng-if="logItem.showMore" class="log_message" name="logFullMessage">
                                            <div class="full" ng-bind-html="$ctrl.getFullLogMessage(logItem)"></div>
                                            <div><a href="#" ng-click="$ctrl.switchMoreLess($event, logItem)">Show less</a></div>
                                        </div>
                                        <div class="log_message" name="logMessage" ng-if="!logItem.showMore && !$ctrl.isMobile">{{logItem.message | cut:true:255:' ...'}} <a href="#" ng-if="logItem.message.length > 255" ng-click="$ctrl.switchMoreLess($event, logItem)">Show more</a></div>
                                        <div class="log_message" name="logMessage" ng-if="!logItem.showMore && $ctrl.isMobile">{{logItem.message | cut:true:55:' ...'}} <a href="#" ng-if="logItem.message.length > 55" class="log_button" ng-click="$ctrl.switchMoreLess($event, logItem)">Show more</a></div>
                                    </div>
                                    <div class="testrun-info__tab-table-col _menu">
                                        <div class="testrun-info__tab-table-col _menu-wrapper">
                                            <md-menu ng-if="$ctrl.selectedLogRow === $index">
                                                <md-button name="logsSetting" aria-label="Logs settings"
                                                    class="md-icon-button setting-menu_button" data-ng-click="$mdMenu.open($event)">
                                                    <md-icon class="material-icons">more_vert</md-icon>
                                                </md-button>
                                                <md-menu-content width="2" class="fixed-md-menu-content">
                                                    <md-menu-item>
                                                        <md-button name="copyLine" ng-click="$ctrl.copyLogLine(logItem)">
                                                            Copy line
                                                        </md-button>
                                                    </md-menu-item>
                                                    <md-menu-item>
                                                        <md-button name="copyPermalink" ng-click="$ctrl.copyLogPermalink()">
                                                            Copy permalink
                                                        </md-button>
                                                    </md-menu-item>
                                                </md-menu-content>
                                            </md-menu>
                                        </div>
                                    </div>
                                </div>
                                <div class="testrun-info__tab-table-row _empty" ng-if="!$ctrl.logs.length">
                                    <div class="testrun-info__tab-table-col">
                                        {{ $ctrl.isLogsLoading ? 'Loading...' : 'No logs' }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                </div>
            </div>
        </div>
    </div>
</div>
